﻿using System;

using System.Web.UI;

using System.Data;
using Telerik.Web.UI;
using System.Web.Script.Serialization;


public partial class TransferAndTemplates : System.Web.UI.Page
{
    private JavaScriptSerializer serializer;
    public JavaScriptSerializer Serializer
    {
        get
        {
            if (serializer == null)
            {
                serializer = new JavaScriptSerializer();
            }

            return serializer;
        }
    }

    protected void Page_Load(object sender, EventArgs e)
    {
        SourceRadListBox.ItemDataBound += new RadListBoxItemEventHandler(SourceRadListBox_ItemDataBound);
        SourceRadListBox.Transferring += new RadListBoxTransferringEventHandler(SourceRadListBox_Transferring);
     
        if (!IsPostBack)
        {
            LoadSampleData();
        }
      
    }

    void SourceRadListBox_Transferring(object sender, RadListBoxTransferringEventArgs e)
    {
        e.Cancel = true;

        foreach (RadListBoxItem item in e.Items)
        {
            var dataItem = Serializer.Deserialize<DogInfo>(item.Attributes["dataItem"]);
            var destItem = new Telerik.Web.UI.RadListBoxItem();
            destItem.Attributes["dataItem"] = item.Attributes["dataItem"];

            e.DestinationListBox.Items.Add(destItem);

            destItem.DataItem = dataItem;
            destItem.DataBind();

            e.SourceListBox.Items.Remove(item);
        }
    }


    void SourceRadListBox_ItemDataBound(object sender, RadListBoxItemEventArgs e)
    {
        var serializedDataItem = GetSerializedDataItem((DataRowView)e.Item.DataItem);
        e.Item.Attributes.Add("dataItem", serializedDataItem);
    }

    private void LoadSampleData()
    {
        DataSet ds = new DataSet();

        ds.ReadXml(Server.MapPath("~/CustomersAndDogs.xml"));
        SourceRadListBox.DataSource = ds;
        SourceRadListBox.DataBind();
    }

    private string GetSerializedDataItem(DataRowView view)
    {
        var info = new DogInfo()
        {
            DogName = (string)DataBinder.Eval(view, "DogName"),
            OwnerFullName = (string)DataBinder.Eval(view, "OwnerFullName")
        };

        return Serializer.Serialize(info);
    }
}

public class DogInfo
{
    public string DogName { get; set; }
    public string OwnerFullName { get; set; }
}
